#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

#define SZ 44

int fibo[SZ];

int getfibo(char *s) {
    int l=strlen(s),i,n=0;
    for (i=0;i<l;i++) n+=(s[i]-'0')*fibo[l-i-1];
    return n;
}

void hrom(int n,char *s) {
    int i;
    for (i=SZ-2;i>=0;i--) {
	if (fibo[i]<=n) {
/*	    printf("fsa %d %d %d\n",n,i,fibo[i]);*/
	    n-=fibo[i];
	    s[SZ-i-2]='1';
	} else s[SZ-i-2]='0';
    }
    s[SZ-1]=0;
}

char *index2(char *s, char c)
{
    if (!index(s,c)) {
	*(s+1)=0;
	return s;
    } else return index(s,c);
}

int main(void)
{
    char pin[SZ*2],pout[SZ],*in2,pinout[SZ*2],in2out[SZ*2],buffer[SZ];
    int i,n;
    fibo[0]=1; fibo[1]=2;
    for (i=2;i<SZ;i++) {
	fibo[i]=fibo[i-1]+fibo[i-2];
    }
    buffer[0]='0';
    while (1) {
	int i1,i2,i3,f;
	
	if (gets(pin)==NULL) break;
	if (!strlen(pin)) break;
	in2=index(pin,' ');
	*(in2++)=0;
	n=getfibo(pin)+getfibo(in2);
	hrom(n,pout);
	
	hrom(getfibo(pin),pinout);
	hrom(getfibo(in2),in2out);
	
	i1 = strlen(index2(pinout,'1'));
	i2 = strlen(index2(in2out,'1'));
	i3 = strlen(index2(pout, '1'));
	
	for (f = 0; f<i3-i1+2; f++) printf(" ");
	printf("%s\n", index2(pinout,'1'));
	printf("+");
	for (f = 1; f<i3-i2+2; f++) printf(" ");
	printf("%s\n", index2(in2out,'1'));
	printf("  ");
	for (f = 1; f < i3+1; f++) printf("-");
	printf("\n  %s\n\n", index2(pout, '1'));
    }
    
    return 0;
}
